<?

require_once "path.inc";
require_once "blitzcms.inc";
require_once "local.inc";

/*
$NODES = array(
	"http://node1.blitzcms.org/",
	"http://node2.blitzcms.org/",
	"http://node3.blitzcms.org/",
	"http://node4.blitzcms.org/",
	"http://node5.blitzcms.org/",
	"http://node6.blitzcms.org/",
);
*/

$NODES[] = "http://$_SERVER[HTTP_HOST]/";


$db =& BLZConfig("db");

$sql[] = "DROP TABLE IF EXISTS `blz_attributes`";
$sql[] = "CREATE TABLE `blz_attributes` (" .
		"`id` varchar( 32 ) NOT NULL default ''," .
		"`parent_id` varchar( 32 ) NOT NULL default ''," .
		"`mdate` int( 10 ) NOT NULL default '0'," .
		"`usec` int( 6 ) NOT NULL default '0'," .
		"`udate` int( 10 ) NOT NULL default '0'," .
		"`urn` varchar( 128 ) NOT NULL default ''," .
		"`class` varchar( 64 ) NOT NULL default ''," .
		"`replica` int( 1 ) NOT NULL default '0'," .
		"`deleted` int( 1 ) NOT NULL default '0'," .
		"`system` int( 1 ) NOT NULL default '0'," .
		"PRIMARY KEY ( `id` , `mdate` , `usec` ) ," .
		"KEY `deleted` ( `deleted` ), " .
		"KEY `replica` ( `replica` )" .
		") ENGINE = MYISAM";
$sql[] = "DROP TABLE IF EXISTS `blz_nodes`";
$sql[] = "CREATE TABLE `blz_nodes` (" .
		"`id` varchar( 32 ) NOT NULL default ''," .
		"`server_uri` text NOT NULL ," .
		"`public_key` text NOT NULL ," .
		"`private_key` text NOT NULL ," .
		"`private_pass` text NOT NULL ," .
		"`last_contact` int( 10 ) NOT NULL default '0'," .
		"`last_rtt` float NOT NULL default '0'," .
		"`rtt_avg` float NOT NULL default '0'," .
		"PRIMARY KEY ( `id` )" .
		") ENGINE = MYISAM";
$sql[] = "DROP TABLE IF EXISTS `blz_tokens`";
$sql[] = "CREATE TABLE `blz_tokens` (" .
		"`token` varchar( 32 ) NOT NULL default ''," .
		"`status` int( 1 ) NOT NULL default '0'," .
		"`origin` varchar( 128 ) NOT NULL default ''," .
		"PRIMARY KEY ( `token` )" .
		") ENGINE = MYISAM";
			
foreach ($sql as $query) {
	$result = $db->query($query);
		
	if (PEAR::isError($result))
		return new PEAR_Error($result->getMessage()."<br/>".$db->last_query,0,PEAR_ERROR_DIE);
}

debug("MADE DB TABLES");

// TODO - Remember to delete private keys for peer nodes, so there is only one private key per node!
foreach ($NODES as $SERVER_URI) {
	$private_pass = md5(crypt($SERVER_URI,$SERVER_URI)); // Important! This password is needed to sign outgoing messages
	$ossl = new OpenSSL;
	$ossl->set_privkeypass($private_pass);
	$ossl->do_csr("DK", "Copenhagen", "Copenhagen", "Blitz", "Internet", "Certificate Signer", "certificates@blitzcms.org");
	$private_key = $ossl->get_privatekey();
	$public_key = $ossl->get_publickey();
	
	$fields = array(
		"id" => md5(BLZMicrotime().rand(1,1000)),
		"server_uri" => $SERVER_URI,
		"public_key" => $public_key,
		"private_key" => $private_key,
		"private_pass" => $private_pass,
	);

	$result = $db->autoExecute("blz_nodes",$fields);
}

if (PEAR::isError($result))
	return new PEAR_Error($result->getMessage()."<br/>".$db->last_query,0,PEAR_ERROR_DIE);

// Make some basic structure on the first mirror
$class = new BLZClass("helloworld",array("greeting,text"));
$class->save();

$firstpage = new HelloWorld();
$firstpage->urn = "Greetings from Blitz";
$firstpage->greeting = "Hello World";

if ($firstpage->save())
	debug("OK");
else
	debug("OOPS");

?>
